require ("math")

WIDTH = 700
HEIGHT = 450
PADDLE_WIDTH = 64
PADDLE_HEIGHT = 128

velocity = {}

ball = {}
score = {}
score[1] = 0
score[2] = 0

function love.load ()
	
	paddle1 = {}
	paddle1.x = 0
	paddle1.image = love.graphics.newImage ("textures/paddle1.png")

	paddle2 = {}
	paddle2.x = WIDTH - PADDLE_WIDTH
	paddle2.image = love.graphics.newImage ("textures/paddle1.png")

	init ()
	ball_init ()
	ball.image = love.graphics.newImage ("textures/ball.png")

	love.graphics.setFont(love.graphics.newFont(24))

end


function love.draw ()
	
	love.graphics.setColor (128, 128, 128)

	love.graphics.draw (paddle1.image, paddle1.x, paddle1.y)
	love.graphics.draw (paddle2.image, paddle2.x, paddle2.y)
	love.graphics.draw (ball.image, ball.x, ball.y)
	love.graphics.print (score[1], 330, 100)
	love.graphics.print ("/", 350, 100)
	love.graphics.print (score[2], 365, 100)

end

function love.update (dt)
	
	if ball.y < 0 or ball.y > HEIGHT - 48 then
		velocity.y = - velocity.y
	end

	if ball.x < PADDLE_WIDTH then
		if ball.y > paddle1.y and ball.y < paddle1.y + PADDLE_HEIGHT then
			velocity.x = - velocity.x - velocity.x * 2 / 10
		else
			score[2] = score[2] + 1
			ball_init ()
		end
	elseif ball.x > WIDTH - PADDLE_WIDTH - 48 then
		if ball.y > paddle2.y and ball.y < paddle2.y + PADDLE_HEIGHT then
			velocity.x = - velocity.x - velocity.x * 2 / 10
		else
			score[1] = score[1] +1
			ball_init ()
		end
	end

	if paddle1.y < 0 and paddle1.velocity < 0 then
		-- nothing
	elseif paddle1.y > HEIGHT - PADDLE_HEIGHT and paddle1.velocity > 0 then
		-- nothing
	else
		paddle1.y = paddle1.y + paddle1.velocity
	end

	if velocity.y > 0 then
		paddle2.y = paddle2.y + 4
	end

	if paddle2.y < 0 and velocity.y > 0 then
		paddle2.y = 0
	elseif paddle2.y > HEIGHT - PADDLE_HEIGHT and velocity.y > 0 then
		paddle2.y = HEIGHT - PADDLE_HEIGHT
	else
		paddle2.y = paddle2.y + paddle2.velocity
	end

	ball.x = ball.x + velocity.x
	ball.y = ball.y + velocity.y

end

function love.keypressed (key, unicode)
	
	if love.keyboard.isDown ("s") then
		paddle1.velocity = paddle1.velocity + 4
	end

	if love.keyboard.isDown ("r") then
		ball_init ()
		init ()
	end

end

function love.keyreleased (key, unicode)
	
	if key == "s" then
		paddle1.velocity = paddle1.velocity - 4
	end

end

function ball_init (i)
	
	ball.x = WIDTH/2
	ball.y = HEIGHT/2

	velocity.x = math.random (-4, -2)
	velocity.y = math.random (1, 2)

end

function init ()
	
	paddle1.y = HEIGHT/2
	paddle2.y = HEIGHT/2

	paddle1.velocity = -2
	paddle2.velocity = -2

	score[1] = 0
	score[2] = 0

end